Qore Programming Language Reference Manual: <object> Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
<object> Class Reference

Methods in this pseudo-class can be executed on objects. More...

Inheritance diagram for Qore::<object>:
[legend]

## Public Member Functions
string | className ()
| Returns the class name of the object. More...
bool | empty ()
| Returns True if the object has no public or private members, False if it does. More...
*string | firstKey ()
| Returns the first member name in the object or NOTHING if the object has no members; if called from outside the object, the first public member name is returned (if any) More...
bool | hasCallableMethod (string name)
| Returns True if the given method exists (can be non-static or static) and is callable from the current context. More...
bool | hasCallableNormalMethod (string name)
| Returns True if the given non-static method exists and is callable from the current context. More...
bool | hasCallableStaticMethod (string name)
| Returns True if the given static method exists and is callable from the current context. More...
bool | isSystem ()
| Returns True if the object is a system object (ie a constant object like stdin, etc), False if not. More...
AbstractIterator | iterator ()
| Returns an ObjectIterator object for the hash. More...
ObjectKeyIterator | keyIterator ()
| Returns a ObjectKeyIterator object for the hash. More...
list | keys ()
| Returns a list of member names of the object; if called from outside the object, only public members are returned. More...
*string | lastKey ()
| Returns the last member name in the object or NOTHING if the object has no members; if called from outside the object, the last public member name is returned (if any) More...
ObjectPairIterator | pairIterator ()
| Returns a ObjectPairIterator object for the hash. More...
int | size ()
| Returns the number of members in the object, public and private. More...
bool | sizep ()
| Returns True since objects can return a non-zero size. More...
int | typeCode ()
| Returns Qore::NT_OBJECT. More...
bool | val ()
| Returns False if the object has no public or private members, True if it does. More...
Public Member Functions inherited from <value>
bool | callp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression is a callable value (ie closures or call references) More...
bool | empty ()
| Returns True; this method will be reimplemented in container types where it may return False. More...
bool | intp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression can be converted to an integer. More...
AbstractIterator | iterator ()
| Returns an iterator object for the value; the default iterator object returned is SingleValueIterator. More...
int | lsize ()
| Returns 1; the return value of this method should give the list size of the value, which is normally 1 for non-lists (except for NOTHING where the size will be 0) and the number of the elements in the list for lists; this method will be reimplemented in other types where it may return other values. More...
int | size ()
| Returns zero; this method will be reimplemented in container types where it may return a non-zero value. More...
bool | sizep ()
| Returns True if the type can return a non-zero size (True for containers including binary objects and strings, False for everything else) More...
bool | strp ()
| Returns False; this method is reimplemented in other types and will return True if the given expression can be converted to a string. More...
bool | toBool ()
| Returns the boolean representation of the value; the default is False. More...
float | toFloat ()
| Returns the floating-point representation of the value; the default is 0.0. More...
int | toInt ()
| Returns the integer representation of the value; the default is 0. More...
number | toNumber ()
| Returns the arbitrary-precision numeric representation of the value; the default is 0. More...
string | toString ()
| Returns the string representation of the value; the default is an empty string. More...
string | type ()
| Returns the string type for the value. More...
int | typeCode ()
| Returns the type code for the value. More...
bool | val ()
| Returns False; this method is reimplemented in other types and will return True if the given expression has a value that would be converted to True according to the rules described in %perl-bool-eval. More...

## Detailed Description

Methods in this pseudo-class can be executed on objects.

## Member Function Documentation

string <object>::className | ( |  | ) |

Returns the class name of the object.

Returns
  the class name of the object

Code Flags:
  CONSTANT

Example:
  my string $cn = $o.className();

bool <object>::empty | ( |  | ) |

Returns True if the object has no public or private members, False if it does.

The opposite of <object>::val()

Returns
  True if the object has no public or private members, False if it does

Code Flags:
  RET_VALUE_ONLY

Example:
  my bool $b = $o.empty();

*string <object>::firstKey | ( |  | ) |

Returns the first member name in the object or NOTHING if the object has no members; if called from outside the object, the first public member name is returned (if any)

Returns
  the first member name in the object or NOTHING if the object has no members; if called from outside the object, the first public member name is returned (if any)

Code Flags:
  RET_VALUE_ONLY

Example:
  my *string $n = $o.firstKey();

See Also
  <object>::lastKey()

bool <object>::hasCallableMethod | ( | string | name | ) |

Returns True if the given method exists (can be non-static or static) and is callable from the current context.

Code Flags:
  CONSTANT

Example:
  my bool $b = $obj.hasCallableMethod("getStatus");

Returns
  True if the given method exists (can be non-static or static) and is callable from the current context

See Also
  - hasCallableNormalMethod()
  - hasCallableStaticMethod

Note
  - returns False if the method doesn't exist or is not callable due to being private, for example
  - if a methodGate() method exists but no explicit definition of the given method exists, then this pseudo-method will return False, but any method name can be called on the object due to the existence of the methodGate() method
  - this pseudo-method will also return True if the given method exists and is accessible in an inherited class

Since
  Qore 0.8.8

bool <object>::hasCallableNormalMethod | ( | string | name | ) |

Returns True if the given non-static method exists and is callable from the current context.

Code Flags:
  CONSTANT

Example:
  my bool $b = $obj.hasCallableNormalMethod("getStatus");

Returns
  True if the given non-static method exists and is callable from the current context

See Also
  - hasCallableMethod()
  - hasCallableStaticMethod

Note
  - returns False if the method doesn't exist or is not callable due to being private, for example
  - if a methodGate() method exists but no explicit definition of the given method exists, then this pseudo-method will return False, but any method name can be called on the object due to the existence of the methodGate() method
  - this pseudo-method will also return True if the given method exists and is accessible in an inherited class

Since
  Qore 0.8.8

bool <object>::hasCallableStaticMethod | ( | string | name | ) |

Returns True if the given static method exists and is callable from the current context.

Code Flags:
  CONSTANT

Example:
  my bool $b = $obj.hasCallableStaticMethod("getStatus");

Returns
  True if the given static method exists and is callable from the current context

See Also
  - hasCallableMethod()
  - hasCallableStaticMethod

Note
  - returns False if the static method doesn't exist or is not callable due to being private, for example
  - this pseudo-method will also return True if the given static method exists and is accessible in an inherited class

Since
  Qore 0.8.8

bool <object>::isSystem | ( |  | ) |

Returns True if the object is a system object (ie a constant object like stdin, etc), False if not.

Returns
  True if the object is a system object (ie a constant object like stdin, etc), False if not

Code Flags:
  CONSTANT

Example:
  my bool $b = $i.isSystem();

AbstractIterator <object>::iterator | ( |  | ) |

Returns an ObjectIterator object for the hash.

Returns
  an ObjectIterator object for the hash

Code Flags:
  CONSTANT

Example:
  map printf("+ %y\n", $1), $obj.iterator();

Since
  Qore 0.8.6

ObjectKeyIterator <object>::keyIterator | ( |  | ) |

Returns a ObjectKeyIterator object for the hash.

Returns
  a ObjectKeyIterator object for the hash

Code Flags:
  CONSTANT

Example:
  map printf("+ %s\n", $1), $obj.keyIterator();

Since
  Qore 0.8.6.2

list <object>::keys | ( |  | ) |

Returns a list of member names of the object; if called from outside the object, only public members are returned.

Returns
  a list of member names of the object; if called from outside the object, only public members are returned

Code Flags:
  RET_VALUE_ONLY

Example:
  my list $l = $o.keys();

*string <object>::lastKey | ( |  | ) |

Returns the last member name in the object or NOTHING if the object has no members; if called from outside the object, the last public member name is returned (if any)

Returns
  the last member name in the object or NOTHING if the object has no members; if called from outside the object, the last public member name is returned (if any)

Code Flags:
  RET_VALUE_ONLY

Example:
  my *string $n = $o.lastKey();

See Also
  <object>::firstKey()

ObjectPairIterator <object>::pairIterator | ( |  | ) |

Returns a ObjectPairIterator object for the hash.

Returns
  a ObjectPairIterator object for the hash

Code Flags:
  CONSTANT

Example:
  map printf("+ %s\n", $1), $obj.pairIterator();

Since
  Qore 0.8.6.2

int <object>::size | ( |  | ) |

Returns the number of members in the object, public and private.

Returns
  the number of members in the object, public and private

Code Flags:
  RET_VALUE_ONLY

Example:
  my int $num = $o.size();

See Also
  <object>::sizep()

bool <object>::sizep | ( |  | ) |

Returns True since objects can return a non-zero size.

Code Flags:
  CONSTANT

Returns
  True since objects can return a non-zero size

See Also
  <object>::size()

Since
  Qore 0.8.9

int <object>::typeCode | ( |  | ) |

Returns Qore::NT_OBJECT.

Returns
  Qore::NT_OBJECT

Code Flags:
  CONSTANT

Example:
  switch ($o.typeCode()) {
  case Qore::NT_OBJECT:
  printf("%y: is an object\n", $o);
  break;
  }

bool <object>::val | ( |  | ) |

Returns False if the object has no public or private members, True if it does.

The opposite of <object>::empty()

Returns
  False if the object has no public or private members, True if it does

Code Flags:
  RET_VALUE_ONLY

Example:
  my bool $b = $o.val();

See Also
  - %perl-bool-eval
  - %strict-bool-eval